unit ungame;

{$mode objfpc}{$H+}

interface

uses
  Classes, MMsystem, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  ExtCtrls, Menus;

type

  { TfrmGame }

  TfrmGame = class(TForm)
    dudes: TImageList;
    Q: TButton;
    P: TButton;
    A: TButton;
    S: TButton;
    D: TButton;
    F: TButton;
    G: TButton;
    H: TButton;
    J: TButton;
    K: TButton;
    L: TButton;
    W: TButton;
    Z: TButton;
    X: TButton;
    C: TButton;
    V: TButton;
    B: TButton;
    N: TButton;
    M: TButton;
    E: TButton;
    R: TButton;
    T: TButton;
    Y: TButton;
    U: TButton;
    I: TButton;
    O: TButton;
    imgDude: TImage;
    labMystery: TLabel;
    labFeedback: TLabel;
    gameMenu: TMainMenu;
    wordlist: TMemo;
    options: TMenuItem;
    menuNewGame: TMenuItem;
    menuQuit: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure menuNewGameClick(Sender: TObject);
    procedure menuQuitClick(Sender: TObject);
    procedure newgame;
    procedure avago(Sender: TObject);
  private

  public

  end;

var
  frmGame: TfrmGame;

implementation

{$R *.lfm}

{ TfrmGame }
Var  mystery  : string;  //the word we are guessing
     numwrong : byte;    //index of hangdude
     ml, gl   : set of char; //storage for mystery and guesses

procedure TfrmGame.FormCreate(Sender: TObject);
begin
  randomize;
  //set up a new game
  newgame;

end;

procedure TfrmGame.menuNewGameClick(Sender: TObject);
begin
  newgame;
end;

procedure TfrmGame.menuQuitClick(Sender: TObject);
begin
  close
end;

procedure TFrmGame.newgame;
var loop    : byte;
    temp : string;
begin
  //set up a new turn in hangman
  numwrong := 0;
  gl := [];
  ml := [];

  //invent a word
  mystery := 'ALBATROSS';
  for loop := 1 to length(mystery) do
     ml := ml + [mystery[loop]];

  //render that word
  temp := '';
  for loop := 1 to length(mystery) do
     temp := temp + '_ ';
  labMystery.Caption:= temp;

  //cleanup display
  dudes.getbitmap(0,imgDude.picture.bitmap);

  //re-enable buttons


end;

procedure TfrmGame.avago(sender:TObject);
var thing  : TButton;
    guess  : char;
    loop   : byte;
    temp   : string;
begin
  //process a letter click
  //grab sender
  thing := sender as TButton;

  //register guess
  guess := thing.caption[1];
  gl := gl + [ guess ];

  //how good is that guess
  if (guess in ml)
     then begin
            //yay, new letter discovered
       		labFeedback.caption := 'Good work!';
            //render the word
            temp :='';
            for loop := 1 to length(mystery) do
               if (mystery[loop] in gl)
                  then temp := temp + mystery[loop]+' '
                  else temp := temp + '_ ';
            labMystery.caption := temp

          end
     else begin
            //nopey nope - error
  		    labFeedback.caption := 'Too bad, try again!';
            //fix the dude, error made
            inc(numwrong);
            if (numwrong <=10)
               then dudes.GetBitmap(numwrong,imgDude.picture.bitmap)


          end;


  //are we at end game yet?



  //disable the letter
  thing.enabled := false;

end;

end.

{
1. endgames - out of guesses - how to stop play?
            - won - yay, stop play also
2. random word from memo box
3. newgame activates all buttons
4. some other game-ify option? Lowest number of guesses?
}

